/*++
Module Name:

    NULLSPI.CPP : 

Abstract:

    Contains all the entry points for the WS2SPI.  This module implements a
    sample WinSock2 service provider.

		Each function just prints out one line to indicate the entrace of a
		function. The sckeleton of the functions comes from the layered spi sample
		code.
    
Author:  xwh@cs.cornell.edu

        
--*/
#include "nullspi.h"

#define XWH1_DEBUG
#ifdef XWH1_DEBUG
#define TestPrint printf
#else
#define TestPrint 0 &&
#endif

SOCKET
WSPAPI
WSPAccept(
    IN SOCKET s,
    OUT struct sockaddr FAR *addr,
    OUT INT FAR *addrlen,
    IN LPCONDITIONPROC lpfnCondition,
    IN DWORD dwCallbackData,
    OUT INT FAR *lpErrno
    )
{
    INT          ReturnValue = INVALID_SOCKET;
		TestPrint("Enter WSPAccept()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPAddressToString(
    IN     LPSOCKADDR lpsaAddress,
    IN     DWORD dwAddressLength,
    IN     LPWSAPROTOCOL_INFOW lpProtocolInfo,
    OUT    LPWSTR lpszAddressString,
    IN OUT LPDWORD lpdwAddressStringLength,
    OUT    LPINT lpErrno )
{
    INT                 ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPAddressToString()\n");
    return ReturnValue;
}

INT
WSPAPI
WSPAsyncSelect(
    IN SOCKET s,
    IN HWND hWnd,
    IN unsigned int wMsg,
    IN long lEvent,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPAsyncSelect()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPBind(
    IN SOCKET s,
    IN const struct sockaddr FAR *name,
    IN INT namelen,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPBind()\n");
    return(ReturnValue);

}

INT
WSPAPI
WSPCancelBlockingCall(OUT INT FAR *lpErrno)
{
    return(WSAEINVAL);
}

INT
WSPAPI
WSPCleanup(
    OUT INT FAR *lpErrno
    )
{
    INT          ReturnValue = SOCKET_ERROR;
		TestPrint(" Enter WSPCleanup()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPCloseSocket(
    IN SOCKET s,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPCloseSocket()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPConnect(
    IN SOCKET s,
    IN const struct sockaddr FAR *name,
    IN INT namelen,
    IN LPWSABUF lpCallerData,
    IN LPWSABUF lpCalleeData,
    IN LPQOS lpSQOS,
    IN LPQOS lpGQOS,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter    WSPConnect()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPDuplicateSocket(
    IN SOCKET s,
    IN DWORD dwProcessID,
    IN LPWSAPROTOCOL_INFOW lpProtocolInfo,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue=SOCKET_ERROR;
		TestPrint("Enter    WSPDuplicateSocket()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPEnumNetworkEvents(
    IN SOCKET s,
    OUT WSAEVENT hEventObject,
    OUT LPWSANETWORKEVENTS lpNetworkEvents,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPEnumNetworkEvents()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPEventSelect(
    IN SOCKET s,
    IN OUT WSAEVENT hEventObject,
    IN long lNetworkEvents,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter  WSPEventSelect()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPGetOverlappedResult(
    IN SOCKET s,
    IN LPWSAOVERLAPPED lpOverlapped,
    IN LPDWORD lpcbTransfer,
    IN BOOL fWait,
    OUT LPDWORD lpdwFlags,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = FALSE;

		TestPrint("Enter WSPGetOverlappedResult()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPGetPeerName(
    IN SOCKET s,
    OUT struct sockaddr FAR *name,
    OUT INT FAR *namelen,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPGetPeerName()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPGetQOSByName(
    IN SOCKET s,
    IN LPWSABUF lpQOSName,
    IN LPQOS lpQOS,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = FALSE;
		TestPrint("Enter WSPGetQOSByName()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPGetSockName(
    IN SOCKET s,
    OUT struct sockaddr FAR *name,
    OUT INT FAR *namelen,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPGetSockName()\n");
    return(ReturnValue);
}

 INT
WSPAPI
WSPGetSockOpt(
    IN SOCKET s,
    IN INT level,
    IN INT optname,
    OUT char FAR *optval,
    OUT INT FAR *optlen,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter GetSocketHandle()\n");
    return(ReturnValue);
}

 INT
WSPAPI
WSPIoctl(
    IN SOCKET s,
    IN DWORD dwIoControlCode,
    IN LPVOID lpvInBuffer,
    IN DWORD cbInBuffer,
    IN LPVOID lpvOutBuffer,
    IN DWORD cbOutBuffer,
    IN LPDWORD lpcbBytesReturned,
    IN LPWSAOVERLAPPED lpOverlapped,
    IN LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine,
    IN LPWSATHREADID lpThreadId,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPIoctl()\n");
    return(ReturnValue);
}

SOCKET
WSPAPI
WSPJoinLeaf(
    IN SOCKET s,
    IN const struct sockaddr FAR *name,
    IN INT namelen,
    IN LPWSABUF lpCallerData,
    IN LPWSABUF lpCalleeData,
    IN LPQOS lpSQOS,
    IN LPQOS lpGQOS,
    IN DWORD dwFlags,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = INVALID_SOCKET;
		TestPrint("Enter WSPJoinLeaf()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPListen(
    IN SOCKET s,
    IN INT backlog,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPListen()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPRecv(
    IN SOCKET s,
    IN LPWSABUF lpBuffers,
    IN DWORD dwBufferCount,
    IN LPDWORD lpNumberOfBytesRecvd,
    IN OUT LPDWORD lpFlags,
    IN LPWSAOVERLAPPED lpOverlapped,
    IN LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine,
    IN LPWSATHREADID lpThreadId,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPRecv()\n");
    return(ReturnValue);
}

 INT
WSPAPI
WSPRecvDisconnect(
    IN SOCKET s,
    IN LPWSABUF lpInboundDisconnectData,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPRecvDisconnect()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPRecvFrom(
    IN  SOCKET s,
    IN  LPWSABUF lpBuffers,
    IN  DWORD dwBufferCount,
    IN  LPDWORD lpNumberOfBytesRecvd,
    IN  OUT LPDWORD lpFlags,
    OUT struct sockaddr FAR *  lpFrom,
    IN  LPINT lpFromlen,
    IN  LPWSAOVERLAPPED lpOverlapped,
    IN  LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine,
    IN LPWSATHREADID lpThreadId,
    OUT INT FAR *lpErrno
    )
{
    INT              ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPRecvFrom()\n");
    return(ReturnValue);
}

typedef struct association
{
    SOCKET  ProviderSocket;
    SOCKET  UserSocket;
} SOCKETASSOCIATION, *PSOCKETASSOCIATION;

typedef struct
{
    UINT                AssociationCount;
    PSOCKETASSOCIATION  Associations;
} SOCKETMAP, *PSOCKETMAP;

INT
WSPAPI
WSPSelect(
    IN INT nfds,
    IN OUT fd_set FAR *readfds,
    IN OUT fd_set FAR *writefds,
    IN OUT fd_set FAR *exceptfds,
    IN const struct timeval FAR *timeout,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPSelect()\n");
    return(ReturnValue);
}

 INT
WSPAPI
WSPSend(
    IN SOCKET s,
    IN LPWSABUF lpBuffers,
    IN DWORD dwBufferCount,
    IN LPDWORD lpNumberOfBytesSent,
    IN DWORD dwFlags,
    IN LPWSAOVERLAPPED lpOverlapped,
    IN LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine,
    IN LPWSATHREADID lpThreadId,
    OUT INT FAR *lpErrno
    )
{
    INT              ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPSend()\n");
    return(ReturnValue);
}

 INT
WSPAPI
WSPSendDisconnect(
    IN SOCKET s,
    IN LPWSABUF lpOutboundDisconnectData,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPSendDisconnect()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPSendTo(
    IN SOCKET s,
    IN LPWSABUF lpBuffers,
    IN DWORD dwBufferCount,
    IN LPDWORD lpNumberOfBytesSent,
    IN DWORD dwFlags,
    IN const struct sockaddr FAR *  lpTo,
    IN INT iTolen,
    IN LPWSAOVERLAPPED lpOverlapped,
    IN LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine,
    IN LPWSATHREADID lpThreadId,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue =SOCKET_ERROR;
		TestPrint("Enter WSPSendTo()\n");
    return(ReturnValue);
}

 INT
WSPAPI
WSPSetSockOpt(
    IN SOCKET s,
    IN INT level,
    IN INT optname,
    IN const char FAR *optval,
    IN INT optlen,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPSetSockOpt()\n");
    return(ReturnValue);
}

INT
WSPAPI
WSPShutdown(
    IN SOCKET s,
    IN INT how,
    OUT INT FAR *lpErrno
    )
{
    INT ReturnValue = SOCKET_ERROR;
		TestPrint("Enter WSPShutdown()\n");
    return(ReturnValue);
}

SOCKET
WSPAPI
WSPSocket(
    IN int af,
    IN int type,
    IN int protocol,
    IN LPWSAPROTOCOL_INFOW lpProtocolInfo,
    IN GROUP g,
    IN DWORD dwFlags,
    OUT INT FAR *lpErrno
    )
{
    INT    ReturnValue = INVALID_SOCKET;
		int    error;

		TestPrint("Enter WSPSocket()\n");
		ReturnValue = gupCallTable.lpWPUCreateSocketHandle( gCatalog, 0, & error);

		if ( ReturnValue == INVALID_SOCKET )
			TestPrint (" WSPSocket() returning INVALID_SOCKET \n");
		else
			TestPrint (" WSPSocket() returning a valid Socket handle\n");
		return(ReturnValue);
}

INT
WSPAPI
WSPStringToAddress(
		IN     LPWSTR AddressString,
		IN     INT AddressFamily,
		IN     LPWSAPROTOCOL_INFOW lpProtocolInfo,
		OUT    LPSOCKADDR lpAddress,
		IN OUT LPINT lpAddressLength,
		IN OUT LPINT lpErrno )
{
	INT                 ReturnValue = SOCKET_ERROR;
	TestPrint("Enter WSPStringToAddress()\n");
	return(ReturnValue);
}

INT
WSPAPI
WSPStartup(
		WORD wVersion,
		LPWSPDATA lpWSPData,
		LPWSAPROTOCOL_INFOW lpProtocolInfo,
		WSPUPCALLTABLE UpcallTable,
		LPWSPPROC_TABLE lpProcTable )
{
	TestPrint("Enter WSPStartup()\n" ) ;
	INT ReturnCode;

	EnterCriticalSection(&gInitCriticalSection);

	ReturnCode   = NO_ERROR;
	gupCallTable = UpcallTable ;
	gCatalog     = lpProtocolInfo->dwCatalogEntryId;

	LeaveCriticalSection(&gInitCriticalSection);

	TestPrint ( " MY Catalog = %d\n", gCatalog );


	lpProcTable->lpWSPAccept              = WSPAccept;
	lpProcTable->lpWSPAddressToString     = WSPAddressToString;
	lpProcTable->lpWSPAsyncSelect         = WSPAsyncSelect;
	lpProcTable->lpWSPBind                = WSPBind;
	lpProcTable->lpWSPCancelBlockingCall  = WSPCancelBlockingCall;
	lpProcTable->lpWSPCleanup             = WSPCleanup;
	lpProcTable->lpWSPCloseSocket         = WSPCloseSocket;
	lpProcTable->lpWSPConnect             = WSPConnect;
	lpProcTable->lpWSPDuplicateSocket     = WSPDuplicateSocket;
	lpProcTable->lpWSPEnumNetworkEvents   = WSPEnumNetworkEvents;
	lpProcTable->lpWSPEventSelect         = WSPEventSelect;
	lpProcTable->lpWSPGetOverlappedResult = WSPGetOverlappedResult;
	lpProcTable->lpWSPGetPeerName         = WSPGetPeerName;
	lpProcTable->lpWSPGetSockName         = WSPGetSockName;
	lpProcTable->lpWSPGetSockOpt          = WSPGetSockOpt;
	lpProcTable->lpWSPGetQOSByName        = WSPGetQOSByName;
	lpProcTable->lpWSPIoctl               = WSPIoctl;
	lpProcTable->lpWSPJoinLeaf            = WSPJoinLeaf;
	lpProcTable->lpWSPListen              = WSPListen;
	lpProcTable->lpWSPRecv                = WSPRecv;
	lpProcTable->lpWSPRecvDisconnect      = WSPRecvDisconnect;
	lpProcTable->lpWSPRecvFrom            = WSPRecvFrom;
	lpProcTable->lpWSPSelect              = WSPSelect;
	lpProcTable->lpWSPSend                = WSPSend;
	lpProcTable->lpWSPSendDisconnect      = WSPSendDisconnect;
	lpProcTable->lpWSPSendTo              = WSPSendTo;
	lpProcTable->lpWSPSetSockOpt          = WSPSetSockOpt;
	lpProcTable->lpWSPShutdown            = WSPShutdown;
	lpProcTable->lpWSPSocket              = WSPSocket;
	lpProcTable->lpWSPStringToAddress     = WSPStringToAddress;

	// Set the version info
	lpWSPData->wVersion     = MAKEWORD(2,2); 
	lpWSPData->wHighVersion = MAKEWORD(2,2);

	return(ReturnCode);
}
