
/*

Module Name:

    nullspi.h

Abstract:

    This file includes all the headers required to build nullspi.dll
		GUID, global variables.

		xwh@cs.cornell.edu
*/

#ifndef _NULLSPI_H
#define _NULLSPI_H

#define WIN32_LEAN_AND_MEAN

//
// Turn off "declspec" decoration of entrypoints defined in WINSOCK2.H.
//

#define WINSOCK_API_LINKAGE

/* nonstandard extension 'single line comment' was used */
#pragma warning(disable: 4001)
// argument differs in indirection to slightly different base types
#pragma warning(disable: 4057)
// unreferenced formal parameter
#pragma warning(disable: 4100)
// named type definition in parentheses
#pragma warning(disable: 4115)
// nonstandard extension used : nameless struct/union
#pragma warning(disable: 4201)
// nonstandard extension used : benign typedef redefinition
#pragma warning(disable: 4209)
// nonstandard extension used : bit field types other than int
#pragma warning(disable: 4214)
// unreferenced inline function has been removed
#pragma warning(disable: 4514)
// Note: Creating precompiled header 
#pragma warning(disable: 4699)

#include <windows.h>
#include <ws2spi.h>
#include <wtypes.h> 
#include <assert.h>
#include <winnt.h>
#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>

#define CONFIGURATION_KEY TEXT("SOFTWARE\\WinSock2\\NULL_SPI")

// {2FE5DBD1-1686-11d0-B670-00A0247B1EEC}
static GUID NullSPIGuid= 
{ 0x2fe5dbd1, 0x1686, 0x11d0, { 
	0xb6, 0x70, 0x0, 0xa0, 0x24, 0x7b, 0x1e, 0xec } 
};
                            
extern long             thread_count ;
extern HMODULE          g_hinst      ;
extern CRITICAL_SECTION gInitCriticalSection;
extern WSPUPCALLTABLE   gupCallTable;
extern INT              gCatalog;

#endif     // _NULLSPI_H
