/*
 * Filename:    ehcoserv.cpp
 *
 * Author: xwh1@cornell.edu
 */

#define UNICODE

#include <ws2spi.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ws2atm.h>
#include <iostream.h>

struct  unet_fe_addr {
	char addr[6];
};

struct sockaddr_unet_fe
{
	unsigned short  family;
	unsigned short  port;
	unet_fe_addr    addr;
	char            zero[6];

};

int str_to_unetaddr ( char* str, unsigned short port, sockaddr_unet_fe* addr)
{
	unsigned int mac_addr[6];
	if (sscanf(str,"%x:%x:%x:%x:%x:%x", &(mac_addr[0]),
			&(mac_addr[1]), &(mac_addr[2]), &(mac_addr[3]),
			&(mac_addr[4]), &(mac_addr[5])) != 6)
		return -1;
	for (int  i=0;i<6;i++)
		addr->addr.addr[i] = (char)mac_addr[i];
	addr->port = port;
	return 0;
}



int main()
{
	WORD                wVersionRequested;
	WSADATA             wsaData;
	SOCKET              s ;
	sockaddr_unet_fe    addr;
	char                buf [1024];


	wVersionRequested = MAKEWORD( 2, 0 );

	if (  WSAStartup( wVersionRequested, &wsaData )){
		return 0;
	}

	if ( LOBYTE( wsaData.wVersion ) != 2 || HIBYTE( wsaData.wVersion ) != 0 ) {
		WSACleanup( );
		return 0; 
	}

	str_to_unetaddr ( "00:01:c0:43:39:ef", 0x43, & addr);


	s = socket ( AF_ATM, SOCK_DGRAM, IPPROTO_UDP);

	if (s == INVALID_SOCKET) {
		cout << "invalid socket"<< endl;
		exit (0);
	}

	int tolen = sizeof ( addr);
	for (;;) {
		recvfrom ( s,  buf, 1024, 0, (struct sockaddr *) & addr, & tolen);
		cout << "Recv : " << buf << endl;
	}

	return 0;
}
