/*
 * Filename:    testspi.cpp
 *
 * Makes a few calls to test SPI
 *
 * Author: xwh@cs.cornell.edu
 */
#define UNICODE

#include <ws2spi.h>
#include <stdio.h>
#include <string.h>
#include <tchar.h>
#include <stdlib.h>
#include <malloc.h>
#include <iostream.h>

struct  unet_fe_addr {
  char addr[6];
};

struct sockaddr_unet_fe
{
  unsigned short  family;
  unsigned short  port;
  unet_fe_addr    addr;
  char            zero[6];
};

int str_to_unetaddr ( char* str, unsigned short port, sockaddr_unet_fe* addr)
{
  unsigned int mac_addr[6];
  if (sscanf(str,"%x:%x:%x:%x:%x:%x", &(mac_addr[0]),
      &(mac_addr[1]), &(mac_addr[2]), &(mac_addr[3]),
      &(mac_addr[4]), &(mac_addr[5])) != 6)
    return -1;
	for (int  i=0;i<6;i++)
		addr->addr.addr[i] = (char)mac_addr[i];
	addr->port = port;
	return 0;
}

int main()
{			
	sockaddr_unet_fe addr;
	WORD             wVersionRequested;
	WSADATA          wsaData;
	int              err;

	wVersionRequested = MAKEWORD( 2, 0 );

	err = WSAStartup( wVersionRequested, &wsaData );
	if ( err )
		return 0;

	/* Confirm that the WinSock DLL supports 2.0.*/
	if ( LOBYTE( wsaData.wVersion ) != 2 || HIBYTE( wsaData.wVersion ) != 0 ) {
		WSACleanup( );
		return 0; 
	}

	/* The WinSock DLL is acceptable. Proceed. */

	SOCKET s ;
	char buf [1024];

	s = socket ( AF_ATM, SOCK_DGRAM, IPPROTO_UDP);
	if (s == INVALID_SOCKET){
		cout << "invalid socket"<< endl;
		exit(-1);
	}

	strcpy ( buf, "hello, Wilson says hi!!");
	str_to_unetaddr ( "00:00:c0:49:47:c8", 0x43, & addr); // change for your own
	sendto ( s,  buf, strlen( buf) +1, 0, 
			(struct sockaddr *) &addr, sizeof(addr));
	return 0;
}
