/* 
 * A program that prints out the ethernet address of a tulip board.
 * X. Huang
 */


#include <windows.h>
#include <winioctl.h>
#include <stdio.h>
#include <stdlib.h>

#include "unetuser.h"
#include "libunet.h"

int __cdecl main(int  argc, char *argv[]) {
	UNET_INFO_RESPONSE info;
	HANDLE             hDriver;
	int                i;

	hDriver = unet_opendev(UNET_DEVID_TULIP, 0, &info);
	printf("Tulip Board ethernet addr:  ");

	for (i=0;i<6;i++)
		printf("%02x%c", info.local_addr.fe.macAddr[i], (i==5)?'\n':':');

	CloseHandle(hDriver);
	return 0;
}

